import { isSource as r, Source as a } from "../language/source.mjs";

import { TokenKind as e } from "../language/tokenKind.mjs";

import { Lexer as n, isPunctuatorTokenKind as i } from "../language/lexer.mjs";

import { printBlockString as o } from "../language/blockString.mjs";

function stripIgnoredCharacters(t) {
  var m = r(t) ? t : new a(t);
  var s = m.body;
  var g = new n(m);
  var v = "";
  var d = !1;
  while (g.advance().kind !== e.EOF) {
    var l = g.token;
    var f = l.kind;
    var u = !i(l.kind);
    if (d) {
      if (u || l.kind === e.SPREAD) {
        v += " ";
      }
    }
    var c = s.slice(l.start, l.end);
    if (f === e.BLOCK_STRING) {
      v += o(l.value);
    } else {
      v += c;
    }
    d = u;
  }
  return v;
}

export { stripIgnoredCharacters };
