import { Kind as e } from "../language/kinds.mjs";

import { GraphQLNonNull as r, GraphQLList as t } from "../type/definition.mjs";

function typeFromAST(n, m) {
  switch (m.kind) {
   case e.LIST_TYPE:
    var o = typeFromAST(n, m.type);
    return o && new t(o);

   case e.NON_NULL_TYPE:
    var p = typeFromAST(n, m.type);
    return p && new r(p);

   case e.NAMED_TYPE:
    return n.getType(m.name.value);
  }
}

export { typeFromAST };
