"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../error/GraphQLError.js");

var r = require("../../language/kinds.js");

var t = require("../../execution/collectFields.js");

exports.SingleFieldSubscriptionsRule = function SingleFieldSubscriptionsRule(i) {
  return {
    OperationDefinition: function OperationDefinition(n) {
      if ("subscription" === n.operation) {
        var o = i.getSchema();
        var l = o.getSubscriptionType();
        if (l) {
          var s = n.name ? n.name.value : null;
          var a = Object.create(null);
          var u = i.getDocument();
          var c = Object.create(null);
          for (var p = 0, v = u.definitions; p < v.length; p += 1) {
            var f = v[p];
            if (f.kind === r.Kind.FRAGMENT_DEFINITION) {
              c[f.name.value] = f;
            }
          }
          var d = t.collectFields(o, c, a, l, n.selectionSet);
          if (d.size > 1) {
            var m = [].concat(d.values()).slice(1).flat();
            i.reportError(new e.GraphQLError(null != s ? 'Subscription "' + s + '" must select only one top level field.' : "Anonymous Subscription must select only one top level field.", m));
          }
          for (var b = 0, S = d.values(); b < S.length; b += 1) {
            var g = S[b];
            if (g[0].name.value.startsWith("__")) {
              i.reportError(new e.GraphQLError(null != s ? 'Subscription "' + s + '" must not select an introspection top level field.' : "Anonymous Subscription must not select an introspection top level field.", g));
            }
          }
        }
      }
    }
  };
};
