"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../../jsutils/groupBy.js");

var r = require("../../error/GraphQLError.js");

exports.UniqueArgumentNamesRule = function UniqueArgumentNamesRule(n) {
  return {
    Field: checkArgUniqueness,
    Directive: checkArgUniqueness
  };
  function checkArgUniqueness(u) {
    var t;
    var a = null !== (t = u.arguments) && void 0 !== t ? t : [];
    for (var i = 0, o = e.groupBy(a, (function(e) {
      return e.name.value;
    })); i < o.length; i += 1) {
      var s = o[i];
      var c = s[1];
      if (c.length > 1) {
        n.reportError(new r.GraphQLError('There can be only one argument named "' + s[0] + '".', c.map((function(e) {
          return e.name;
        }))));
      }
    }
  }
};
