"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var r = require("../error/GraphQLError.js");

var e = require("../language/visitor.js");

var i = require("../type/validate.js");

var a = require("../utilities/TypeInfo.js");

var t = require("./specifiedRules.js");

var n = require("./ValidationContext.js");

exports.assertValidSDLExtension = function assertValidSDLExtension(r, i) {
  var a = function validateSDL(r, i, a) {
    if (void 0 === a) {
      a = t.specifiedSDLRules;
    }
    var o = [];
    var s = new n.SDLValidationContext(r, i, (function(r) {
      o.push(r);
    }));
    var v = a.map((function(r) {
      return r(s);
    }));
    e.visit(r, e.visitInParallel(v));
    return o;
  }(r, i);
  if (0 !== a.length) {
    throw new Error(a.map((function(r) {
      return r.message;
    })).join("\n\n"));
  }
};

exports.validate = function validate(o, s, v, l, u) {
  if (void 0 === v) {
    v = t.specifiedRules;
  }
  if (void 0 === u) {
    u = new a.TypeInfo(o);
  }
  var d;
  var f = null !== (d = null == l ? void 0 : l.maxErrors) && void 0 !== d ? d : 100;
  i.assertValidSchema(o);
  var p = {};
  var c = [];
  var h = new n.ValidationContext(o, s, u, (function(e) {
    if (c.length >= f) {
      c.push(new r.GraphQLError("Too many validation errors, error limit reached. Validation aborted."));
      throw p;
    }
    c.push(e);
  }));
  var x = e.visitInParallel(v.map((function(r) {
    return r(h);
  })));
  try {
    e.visit(s, a.visitWithTypeInfo(u, x));
  } catch (r) {
    if (r !== p) {
      throw r;
    }
  }
  return c;
};
