import { GraphQLError as r } from "../error/GraphQLError.mjs";

import { visitInParallel as i, visit as o } from "../language/visitor.mjs";

import { assertValidSchema as t } from "../type/validate.mjs";

import { TypeInfo as n, visitWithTypeInfo as a } from "../utilities/TypeInfo.mjs";

import { specifiedRules as e, specifiedSDLRules as m } from "./specifiedRules.mjs";

import { ValidationContext as s, SDLValidationContext as f } from "./ValidationContext.mjs";

function validate(m, f, u, v, l) {
  if (void 0 === u) {
    u = e;
  }
  if (void 0 === l) {
    l = new n(m);
  }
  var d;
  var p = null !== (d = null == v ? void 0 : v.maxErrors) && void 0 !== d ? d : 100;
  t(m);
  var c = {};
  var h = [];
  var w = new s(m, f, l, (function(i) {
    if (h.length >= p) {
      h.push(new r("Too many validation errors, error limit reached. Validation aborted."));
      throw c;
    }
    h.push(i);
  }));
  var j = i(u.map((function(r) {
    return r(w);
  })));
  try {
    o(f, a(l, j));
  } catch (r) {
    if (r !== c) {
      throw r;
    }
  }
  return h;
}

function assertValidSDLExtension(r, t) {
  var n = function validateSDL(r, t, n) {
    if (void 0 === n) {
      n = m;
    }
    var a = [];
    var e = new f(r, t, (function(r) {
      a.push(r);
    }));
    var s = n.map((function(r) {
      return r(e);
    }));
    o(r, i(s));
    return a;
  }(r, t);
  if (0 !== n.length) {
    throw new Error(n.map((function(r) {
      return r.message;
    })).join("\n\n"));
  }
}

export { assertValidSDLExtension, validate };
