"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var r = require("../language/printLocation.js");

var o = function(o) {
  function GraphQLError(r, t, e, i, n, s, a) {
    o.call(this, r);
    this.name = "GraphQLError";
    this.message = r;
    if (n) {
      this.path = n;
    }
    if (t) {
      this.nodes = t;
    }
    if (e) {
      this.source = e;
    }
    if (i) {
      this.positions = i;
    }
    if (s) {
      this.originalError = s;
    }
    var h = a;
    if (null == h && null != s) {
      var p = s.extensions;
      if (isObjectLike(p)) {
        h = p;
      }
    }
    if (h) {
      this.extensions = h;
    }
  }
  if (o) {
    GraphQLError.__proto__ = o;
  }
  (GraphQLError.prototype = Object.create(o && o.prototype)).constructor = GraphQLError;
  GraphQLError.prototype.toJSON = function toJSON() {
    var r = {
      message: this.message
    };
    if (null != this.locations) {
      r.locations = this.locations;
    }
    if (null != this.path) {
      r.path = this.path;
    }
    if (null != this.extensions && Object.keys(this.extensions).length > 0) {
      r.extensions = this.extensions;
    }
    return r;
  };
  GraphQLError.prototype.toString = function toString() {
    var o = error.message;
    if (error.nodes) {
      for (var t = 0, e = error.nodes; t < e.length; t += 1) {
        var i = e[t];
        if (i.loc) {
          o += "\n\n" + r.printLocation(i.loc);
        }
      }
    } else if (error.source && error.locations) {
      for (var n = 0, s = error.locations; n < s.length; n += 1) {
        o += "\n\n" + r.printSourceLocation(error.source, s[n]);
      }
    }
    return o;
  };
  return GraphQLError;
}(Error);

exports.GraphQLError = o;

exports.formatError = function formatError(r) {
  return r.toJSON();
};

exports.printError = function printError(r) {
  return r.toString();
};
