import { printLocation as r, printSourceLocation as o } from "../language/printLocation.mjs";

var t = function(t) {
  function GraphQLError(r, o, i, n, e, s, a) {
    t.call(this, r);
    this.name = "GraphQLError";
    this.message = r;
    if (e) {
      this.path = e;
    }
    if (o) {
      this.nodes = o;
    }
    if (i) {
      this.source = i;
    }
    if (n) {
      this.positions = n;
    }
    if (s) {
      this.originalError = s;
    }
    var h = a;
    if (null == h && null != s) {
      var p = s.extensions;
      if (isObjectLike(p)) {
        h = p;
      }
    }
    if (h) {
      this.extensions = h;
    }
  }
  if (t) {
    GraphQLError.__proto__ = t;
  }
  (GraphQLError.prototype = Object.create(t && t.prototype)).constructor = GraphQLError;
  GraphQLError.prototype.toJSON = function toJSON() {
    var r = {
      message: this.message
    };
    if (null != this.locations) {
      r.locations = this.locations;
    }
    if (null != this.path) {
      r.path = this.path;
    }
    if (null != this.extensions && Object.keys(this.extensions).length > 0) {
      r.extensions = this.extensions;
    }
    return r;
  };
  GraphQLError.prototype.toString = function toString() {
    var t = error.message;
    if (error.nodes) {
      for (var i = 0, n = error.nodes; i < n.length; i += 1) {
        var e = n[i];
        if (e.loc) {
          t += "\n\n" + r(e.loc);
        }
      }
    } else if (error.source && error.locations) {
      for (var s = 0, a = error.locations; s < a.length; s += 1) {
        t += "\n\n" + o(error.source, a[s]);
      }
    }
    return t;
  };
  return GraphQLError;
}(Error);

function printError(r) {
  return r.toString();
}

function formatError(r) {
  return r.toJSON();
}

export { t as GraphQLError, formatError, printError };
