"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("./kinds.js");

var r = {};

function getEnterLeaveForKind(e, r) {
  var n = e[r];
  if ("object" == typeof n) {
    return n;
  } else if ("function" == typeof n) {
    return {
      enter: n,
      leave: void 0
    };
  }
  return {
    enter: e.enter,
    leave: e.leave
  };
}

function getVisitFn(e, r, n) {
  var t = getEnterLeaveForKind(e, r);
  return n ? t.leave : t.enter;
}

exports.BREAK = r;

exports.getEnterLeaveForKind = getEnterLeaveForKind;

exports.getVisitFn = getVisitFn;

exports.visit = function visit(e, n) {
  var t = [];
  var i = [];
  try {
    var l = function traverse(e, l, v) {
      var a = !1;
      var o = getVisitFn(n, e.kind, !1);
      var f = o && o.call(n, e, l, v, t, i);
      if (!1 === f) {
        return e;
      } else if (null === f) {
        return null;
      } else if (f === r) {
        throw r;
      } else if (f && "string" == typeof f.kind) {
        a = f !== e;
        e = f;
      }
      if (v) {
        i.push(v);
      }
      var s;
      var u = Object.assign({}, e);
      for (var p in e) {
        t.push(p);
        var d = e[p];
        if (Array.isArray(d)) {
          var g = [];
          for (var h = 0; h < d.length; h++) {
            if (null != d[h] && "string" == typeof d[h].kind) {
              i.push(e);
              t.push(h);
              s = traverse(d[h], h, d);
              t.pop();
              i.pop();
              if (void 0 === s) {
                g.push(d[h]);
              } else if (null === s) {
                a = !0;
              } else {
                a = a || s !== d[h];
                g.push(s);
              }
            }
          }
          d = g;
        } else if (null != d && "string" == typeof d.kind) {
          if (void 0 !== (s = traverse(d, p, e))) {
            a = a || d !== s;
            d = s;
          }
        }
        t.pop();
        if (a) {
          u[p] = d;
        }
      }
      if (v) {
        i.pop();
      }
      var c = getVisitFn(n, e.kind, !0);
      var y = c && c.call(n, e, l, v, t, i);
      if (y === r) {
        throw r;
      } else if (void 0 !== y) {
        return y;
      } else if (void 0 !== f) {
        return a ? u : f;
      } else {
        return a ? u : e;
      }
    }(e);
    return void 0 !== l && !1 !== l ? l : e;
  } catch (n) {
    if (n !== r) {
      throw n;
    }
    return e;
  }
};

exports.visitInParallel = function visitInParallel(n) {
  var t = new Array(n.length).fill(null);
  var i = Object.create(null);
  var loop = function() {
    var e = v[l];
    var a = !1;
    var o = new Array(n.length).fill(void 0);
    var f = new Array(n.length).fill(void 0);
    for (var s = 0; s < n.length; ++s) {
      var u = getEnterLeaveForKind(n[s], e);
      var p = u.enter;
      var d = u.leave;
      a || (a = null != p || null != d);
      o[s] = p;
      f[s] = d;
    }
    if (!a) {
      return;
    }
    i[e] = {
      enter: function enter() {
        var e = [], i = arguments.length;
        while (i--) {
          e[i] = arguments[i];
        }
        var l = e[0];
        for (var v = 0; v < n.length; v++) {
          if (null === t[v]) {
            var a;
            var f = null === (a = o[v]) || void 0 === a ? void 0 : a.apply(n[v], e);
            if (!1 === f) {
              t[v] = l;
            } else if (f === r) {
              t[v] = r;
            } else if (void 0 !== f) {
              return f;
            }
          }
        }
      },
      leave: function leave() {
        var e = [], i = arguments.length;
        while (i--) {
          e[i] = arguments[i];
        }
        var l = e[0];
        for (var v = 0; v < n.length; v++) {
          if (null === t[v]) {
            var a;
            var o = null === (a = f[v]) || void 0 === a ? void 0 : a.apply(n[v], e);
            if (o === r) {
              t[v] = r;
            } else if (void 0 !== o && !1 !== o) {
              return o;
            }
          } else if (t[v] === l) {
            t[v] = null;
          }
        }
      }
    };
  };
  for (var l = 0, v = Object.values(e.Kind); l < v.length; l += 1) {
    loop();
  }
  return i;
};
