import { Kind as e } from "./kinds.mjs";

var r = {};

function visitInParallel(n) {
  var i = new Array(n.length).fill(null);
  var t = Object.create(null);
  var loop = function() {
    var e = v[l];
    var a = !1;
    var f = new Array(n.length).fill(void 0);
    var o = new Array(n.length).fill(void 0);
    for (var u = 0; u < n.length; ++u) {
      var s = getEnterLeaveForKind(n[u], e);
      var p = s.enter;
      var d = s.leave;
      a || (a = null != p || null != d);
      f[u] = p;
      o[u] = d;
    }
    if (!a) {
      return;
    }
    t[e] = {
      enter: function enter() {
        var e = [], t = arguments.length;
        while (t--) {
          e[t] = arguments[t];
        }
        var l = e[0];
        for (var v = 0; v < n.length; v++) {
          if (null === i[v]) {
            var a;
            var o = null === (a = f[v]) || void 0 === a ? void 0 : a.apply(n[v], e);
            if (!1 === o) {
              i[v] = l;
            } else if (o === r) {
              i[v] = r;
            } else if (void 0 !== o) {
              return o;
            }
          }
        }
      },
      leave: function leave() {
        var e = [], t = arguments.length;
        while (t--) {
          e[t] = arguments[t];
        }
        var l = e[0];
        for (var v = 0; v < n.length; v++) {
          if (null === i[v]) {
            var a;
            var f = null === (a = o[v]) || void 0 === a ? void 0 : a.apply(n[v], e);
            if (f === r) {
              i[v] = r;
            } else if (void 0 !== f && !1 !== f) {
              return f;
            }
          } else if (i[v] === l) {
            i[v] = null;
          }
        }
      }
    };
  };
  for (var l = 0, v = Object.values(e); l < v.length; l += 1) {
    loop();
  }
  return t;
}

function getEnterLeaveForKind(e, r) {
  var n = e[r];
  if ("object" == typeof n) {
    return n;
  } else if ("function" == typeof n) {
    return {
      enter: n,
      leave: void 0
    };
  }
  return {
    enter: e.enter,
    leave: e.leave
  };
}

function getVisitFn(e, r, n) {
  var i = getEnterLeaveForKind(e, r);
  return n ? i.leave : i.enter;
}

function visit(e, n) {
  var i = [];
  var t = [];
  try {
    var l = function traverse(e, l, v) {
      var a = !1;
      var f = getVisitFn(n, e.kind, !1);
      var o = f && f.call(n, e, l, v, i, t);
      if (!1 === o) {
        return e;
      } else if (null === o) {
        return null;
      } else if (o === r) {
        throw r;
      } else if (o && "string" == typeof o.kind) {
        a = o !== e;
        e = o;
      }
      if (v) {
        t.push(v);
      }
      var u;
      var s = Object.assign({}, e);
      for (var p in e) {
        i.push(p);
        var d = e[p];
        if (Array.isArray(d)) {
          var g = [];
          for (var h = 0; h < d.length; h++) {
            if (null != d[h] && "string" == typeof d[h].kind) {
              t.push(e);
              i.push(h);
              u = traverse(d[h], h, d);
              i.pop();
              t.pop();
              if (void 0 === u) {
                g.push(d[h]);
              } else if (null === u) {
                a = !0;
              } else {
                a = a || u !== d[h];
                g.push(u);
              }
            }
          }
          d = g;
        } else if (null != d && "string" == typeof d.kind) {
          if (void 0 !== (u = traverse(d, p, e))) {
            a = a || d !== u;
            d = u;
          }
        }
        i.pop();
        if (a) {
          s[p] = d;
        }
      }
      if (v) {
        t.pop();
      }
      var c = getVisitFn(n, e.kind, !0);
      var y = c && c.call(n, e, l, v, i, t);
      if (y === r) {
        throw r;
      } else if (void 0 !== y) {
        return y;
      } else if (void 0 !== o) {
        return a ? s : o;
      } else {
        return a ? s : e;
      }
    }(e);
    return void 0 !== l && !1 !== l ? l : e;
  } catch (n) {
    if (n !== r) {
      throw n;
    }
    return e;
  }
}

export { r as BREAK, getEnterLeaveForKind, getVisitFn, visit, visitInParallel };
