"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var r = require("../error/GraphQLError.js");

var e = require("../type/assertName.js");

function isValidNameError(a) {
  if (a.startsWith("__")) {
    return new r.GraphQLError('Name "' + a + '" must not begin with "__", which is reserved by GraphQL introspection.');
  }
  try {
    e.assertName(a);
  } catch (r) {
    return r;
  }
}

exports.assertValidName = function assertValidName(r) {
  var e = isValidNameError(r);
  if (e) {
    throw e;
  }
  return r;
};

exports.isValidNameError = isValidNameError;
