"use strict";

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var e = require("../language/kinds.js");

var r = require("../type/definition.js");

exports.typeFromAST = function typeFromAST(t, n) {
  switch (n.kind) {
   case e.Kind.LIST_TYPE:
    var i = typeFromAST(t, n.type);
    return i && new r.GraphQLList(i);

   case e.Kind.NON_NULL_TYPE:
    var a = typeFromAST(t, n.type);
    return a && new r.GraphQLNonNull(a);

   case e.Kind.NAMED_TYPE:
    return t.getType(n.name.value);
  }
};
