import { groupBy as e } from "../../jsutils/groupBy.mjs";

import { GraphQLError as r } from "../../error/GraphQLError.mjs";

function UniqueArgumentNamesRule(n) {
  return {
    Field: checkArgUniqueness,
    Directive: checkArgUniqueness
  };
  function checkArgUniqueness(u) {
    var t;
    var o = null !== (t = u.arguments) && void 0 !== t ? t : [];
    for (var i = 0, a = e(o, (function(e) {
      return e.name.value;
    })); i < a.length; i += 1) {
      var m = a[i];
      var s = m[1];
      if (s.length > 1) {
        n.reportError(new r('There can be only one argument named "' + m[0] + '".', s.map((function(e) {
          return e.name;
        }))));
      }
    }
  }
}

export { UniqueArgumentNamesRule };
