import { groupBy as r } from "../../jsutils/groupBy.mjs";

import { GraphQLError as e } from "../../error/GraphQLError.mjs";

function UniqueVariableNamesRule(n) {
  return {
    OperationDefinition: function OperationDefinition(a) {
      var i;
      var o = null !== (i = a.variableDefinitions) && void 0 !== i ? i : [];
      for (var t = 0, l = r(o, (function(r) {
        return r.variable.name.value;
      })); t < l.length; t += 1) {
        var u = l[t];
        var m = u[1];
        if (m.length > 1) {
          n.reportError(new e('There can be only one variable named "$' + u[0] + '".', m.map((function(r) {
            return r.variable.name;
          }))));
        }
      }
    }
  };
}

export { UniqueVariableNamesRule };
